#include "CANbusInterface.h"
#include <Arduino.h>

CANbusInterface::CANbusInterface(int cs, int baudRate, int idMode): MCP_CAN(cs){
CS = cs;
switch (baudRate) {
      case 50 : {baudrate = CAN_50KBPS; break;}
      case 100 :{baudrate = CAN_100KBPS; break;}
      case 250 : {baudrate = CAN_250KBPS; break;}
      case 500 : {baudrate = CAN_500KBPS; break;}
      case 1000 : {baudrate = CAN_1000KBPS; break;}
    }
  ID_mode = idMode;
}

CANbusInterface::~CANbusInterface(){}

bool CANbusInterface::init(int mask,int filter){return init(mask,filter,filter,mask,filter,filter,filter,filter);}
bool CANbusInterface::init(int mask0, int filter0, int filter1, int mask1, int filter2, int filter3, int filter4, int filter5) {
int repeat = RETRY_CONNECTION;
while (repeat > 0) {
        if (CAN_OK == begin(baudrate)){break;}else {repeat--;}
        delay(200);
    }
if (repeat == 0) return false;
init_Mask(0,ID_mode, mask0);
init_Filt(0,ID_mode, filter0);
init_Filt(1,ID_mode, filter1);
init_Mask(1,ID_mode, mask1);
init_Filt(2,ID_mode, filter2);
init_Filt(3,ID_mode, filter3);
init_Filt(4,ID_mode, filter4);
init_Filt(5,ID_mode, filter5);
return true;
}

bool CANbusInterface::readMessage (messageCAN & message){
    if (indexRead != indexWrite) {              // s'il y a un message en attente
      message = BufferReceive[indexRead];       // on le lit et le range dans la variable globale "message"
      indexRead = (indexRead+1) % NB_MESSAGES;   // on avance circulairement l'index de lecture
      return true;                              // renvoie true si message a traiter
    }
  return false;                                 // renvoie false si pas de message a traiter
}

int CANbusInterface::writeMessage (messageCAN message){
    return sendMsgBuf(message.id,ID_mode,message.len, message.buf);
}

void CANbusInterface::receiveMessage(){
  long unsigned int Id;           // identificateur
  unsigned char Len = 0;      // longueur
  unsigned char Buf[8];       // donnees

  while (CAN_MSGAVAIL == checkReceive()) {   // tant qu'il y des messages a recevoir
    readMsgBufID(&Id,&Len,Buf);                    // lecture de l'ID et la longueur et des donnees
    BufferReceive[indexWrite].id = Id;           // on sauve l'identificateur
    BufferReceive[indexWrite].len = Len;         // on sauve la longueur
    for (byte index = 0; index < Len; index++){BufferReceive[indexWrite].buf[index] = Buf[index];} // et les donnees dans le buffer de recption
    indexWrite = (indexWrite+1) % NB_MESSAGES;     // on avance circulairement d'un cran l'index de lecture
  }
}


